/* =========================================================================

InDesign ExtendScript

NAME: CalendarWizardCS3
VERSION: 1.0

AUTHOR: Филянин Сергей
DATE  : 24.10.2007

DESCRIPTION: 
Скрипт для автоматической генерации календарных сеток.
Дальнейщую доводку можно осуществлять с помощью изменения стилей
и скрипта calendar_change_params.

E-MAIL: dtp@mail.ru

============================================================================ */
with (app) {
// Подключаем holydays_ru.ini	
	var myIniFile = new File (activeScript.path + "/holydays_ru.ini");
	if (!myIniFile.exists) {
		alert ("Cant open holydays_ini file!");
		exit();
	} else {
		eval ("//@include \'holydays_ru.ini\';");
	}
// Подключаем params_ru.ini
	var myIniFile = new File (activeScript.path + "/params_ru.ini");
	if (!myIniFile.exists) {
		alert ("Cant open params_ini file!");
		exit();
	} else {
		eval ("//@include \'params_ru.ini\';");
	}
// Список вариантов написания дней недели
	var DayOfWeekShow=new Array(dialog_NotPlace);
	for (var i=0; i<DaysOfWeek.length; i++)
	{
		var text_tmp="";
		for (var j=0; j<3; j++)
		{
			text_tmp+=DaysOfWeek[i][j];
			if (j<2)
			{
				text_tmp+=", ";
			}
		}
		text_tmp+="…";

		DayOfWeekShow.push(text_tmp);
		DayOfWeekShow.push(text_tmp.toLowerCase());
		DayOfWeekShow.push(text_tmp.toUpperCase());
	}
// Список вариантов написания месяцев
	var MonthNamesShow= new Array(dialog_NotPlace);
	for (var i=0; i<MonthNames.length; i++)
	{
		var text_tmp="";
		for (var j=0; j<3; j++)
		{
			text_tmp+=MonthNames[i][j];
			if (j<2)
			{
				text_tmp+=", ";
			}
		}
		text_tmp+="…";
		MonthNamesShow.push(text_tmp);
		MonthNamesShow.push(text_tmp.toLowerCase());
		MonthNamesShow.push(text_tmp.toUpperCase());
	}
// Список вариантов расположения календарной сетки
	var MonthPalacement=new Array("12х1", "6x2", "4x3", "3x4", "2x6", "1x12");
	var MonthPalacementSelect=0;

// Диалог параметров создания календаря
	var myDlgBegin = dialogs.add({name: "CalendarWizardCS3"});
	var current_date = new Date();

// Создаём диалоговое окно	
with (myDlgBegin.dialogColumns.add().dialogRows.add())
{
	with (borderPanels.add().dialogColumns.add())
	{
		//Создаем панель параметров страницы
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_PageParams});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myLabel01 = staticTexts.add({staticLabel:dialog_PageWidth});
						var myLabel02 = staticTexts.add({staticLabel:dialog_PageHeights});
						var myLabel03 = staticTexts.add({staticLabel:dialog_PageTopMargin});
						var myLabel04 = staticTexts.add({staticLabel:dialog_PageBottomMargin});
						var myLabel05 = staticTexts.add({staticLabel:dialog_PageLeftMargin});
						var myLabel06 = staticTexts.add({staticLabel:dialog_PageRightMargin});
					}
					with (dialogColumns.add())
					{
						var myDocWidth = realEditboxes.add({editValue:100});
						var myDocHeight = realEditboxes.add({editValue:70});
						var myDocMarginUp = realEditboxes.add({editValue:5});
						var myDocMarginDown = realEditboxes.add({editValue:5});
						var myDocMarginLeft = realEditboxes.add({editValue:5});
						var myDocMarginRight = realEditboxes.add({editValue:5});
					}
				}
		}
		//Создаем панель типа календаря
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_CalendarType});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						with (radiobuttonGroups.add())
						{
							var myKvartalCalendar=radiobuttonControls.add({checkedState: true, staticLabel:dialog_CalendarType1Month});
							var myKarmanCalendar=radiobuttonControls.add({checkedState: false, staticLabel:dialog_CalendarTypeAllMonth});
						}
						var myKvartalWeeks=checkboxControls.add({checkedState: false, staticLabel:dialog_CalendarWeeks});
						var myKvartalWeeks_from1=checkboxControls.add({checkedState: false, staticLabel:dialog_CalendarWeeksFrom1});
					}
				}
		}
		//Создаем панель расположения месяцев
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_MonthPlacement});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myDropMonthPalacement = dropdowns.add({stringList: MonthPalacement, selectedIndex: 2, minWidth: 200});
					}
				}
		}
	}
	with (borderPanels.add().dialogColumns.add())
	{
		//Создаем панель периода действия календаря
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_Period});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myLabe09 = staticTexts.add({staticLabel:dialog_YearBegin});
						var myLabe10 = staticTexts.add({staticLabel:dialog_MonthBegin});
						var myLabel1 = staticTexts.add({staticLabel:dialog_MonthEnd});
					}
					with (dialogColumns.add())
					{
						var myTextYear = realEditboxes.add({editValue: (current_date.getFullYear()+1)});
						var myDropMonth1 = dropdowns.add({stringList: MonthNames[0], selectedIndex: 0, minWidth: 200});
						var myDropMonth2 = dropdowns.add({stringList: MonthNames[0], selectedIndex: 11, minWidth: 200});
					}
				}
		}
		//Создаем панель названия месяцев
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_MonthNames});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myDropMonthNames = dropdowns.add({stringList: MonthNamesShow, selectedIndex: 0, minWidth: 200});
					}
				}
		}
		//Создаем панель ориентации календаря горизонтальный/вертикальный
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_WeekPlacement});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myDropWeek = dropdowns.add({stringList: WeekPositions, selectedIndex: 0, minWidth: 200});
					}
				}
		}
		//Создаем панель названия дней недели
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_WeekNames});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myDropWeekDays = dropdowns.add({stringList: DayOfWeekShow, selectedIndex: 0, minWidth: 200});
					}
				}
		}
		//Создаем панель расположения названий дней недели
		with (dialogRows.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:dialog_WeekNamesPosition});
				with (dialogRows.add())
				{
					with (dialogColumns.add())
					{
						var myDropWeekDaysPosition = dropdowns.add({stringList: DayOfWeekPosition, selectedIndex: 0, minWidth: 200});
					}
				}
		}
		with (dialogRows.add())
		{
			var addYear=checkboxControls.add({checkedState: false, staticLabel:dialog_AddYear});
		}
	}
};
// конец описания диалога
	resultDialog = myDlgBegin.show();
	if (resultDialog)
	{
		// получение параметров календаря из диалога
		var myYear=myTextYear.editValue;
		var myAddYear="";
		var myYearRazdelitel="\t";
		if (addYear.checkedState) myAddYear=myYearRazdelitel+myYear.toString();
		var beginMonth=myDropMonth1.selectedIndex;
		var endMonth=myDropMonth2.selectedIndex;
		if (myKarmanCalendar.checkedState) {beginMonth=0; endMonth=11};
		var myDay=1;
		var myDayOfWeek=0;
		var weekDays=myDropWeekDays.selectedIndex;
		var monthNames=myDropMonthNames.selectedIndex;
		var weekOfdayInMonth;
		MonthPalacementSelect=myDropMonthPalacement.selectedIndex;
		
		if (endMonth<beginMonth)
		{
			alert ("Ошибка: неправильно выбран интервал месяцев");
		}
		else
		{
			var myTextFrame=new Array();
			var myTable=new Array();
			var myPages=new Array();

			// создание документа
			var myDoc=documents.add(false, documentPresets[0]); /// Создаём документ но не отображаем его
			with (myDoc.documentPreferences)
			{
				pageHeight=myDocHeight.editValue+"mm";
				pageWidth=myDocWidth.editValue+"mm";
				facingPages=false;
			}
			with (myDoc.masterSpreads.firstItem().pages.firstItem().marginPreferences)
			{
				top=myDocMarginUp.editValue+"mm";
				bottom=myDocMarginDown.editValue+"mm";
				left=myDocMarginLeft.editValue+"mm";
				right=myDocMarginRight.editValue+"mm";
			}

			// создание cтилей оформления календаря
			MakeStyles();
		
			// заполнение сетки месяцев
			var dayInMonth=CompleteDayInMonth();

			// параметры для прогрессбара
			var myProgressPanel;
			var myMaximumValue = endMonth-beginMonth+1;
			var myProgressBarWidth = 500;
			myProgressPanel = myCreateProgressPanel(myMaximumValue, myProgressBarWidth);
			myProgressPanel.show();
			
			// в зависимости от расположения дней недели создаём календарь
			if (myDropWeek.selectedIndex==0)
			{
				horizontalMonth(beginMonth, endMonth, weekDays, monthNames);
			}
			else
			{
				verticalMonth(beginMonth, endMonth, weekDays, monthNames);
			}	
			myProgressPanel.hide();  // закрываем прогрессбар
			var myWindow = myDoc.windows.add(); /// отображаем документ 
			myWindow.maximize();

		}

		
	}
}

function MakeStyles()
{
// создание новых красок
	// обычные дни недели
	var daysColor = myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [0,0,0,100],
		name: "days"
		});
	// субботы
	var saturdaysColor=myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [0,50,50,0],
		name: "saturdays"
		});
	// воскресенья
	var sundaysColor=myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [0,100,100,0],
		name: "sundays"
		});
	// праздники
	var holydaysColor=myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [0,100,100,0],
		name: "holydays"
		});
	// названия месяцев
	var monthsColor=myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [100,100,0,0],
		name: "months"
		});
	// номера недель
	var weekNumberColor = myDoc.colors.add({
		model: ColorModel.process,
		colorValue: [0,0,0,50],
		name: "weeknumber"
	});


// задание параметров стилей
	// обычные дни недели	
	var myParagraphStyleDays=myDoc.paragraphStyles.add({
		name: "days",
		justification: Justification.rightAlign,
		pointSize: 6,
		position: Position.normal,
		fillColor: daysColor
		});
	// субботы
	var myParagraphStyleSaturdays=myDoc.paragraphStyles.add({
		name: "saturdays",
		basedOn: myParagraphStyleDays,
		fillColor: saturdaysColor
		});
	// воскресенья	
	var myParagraphStyleSundays=myDoc.paragraphStyles.add({
		name: "sundays",
		basedOn: myParagraphStyleDays,
		fillColor: sundaysColor
		});
	// праздники
	var myParagraphStyleHolydays=myDoc.paragraphStyles.add({
		name: "holydays",
		basedOn: myParagraphStyleDays,
		fillColor: holydaysColor
		});
	// недели
	var myParagraphStyleWeekNum=myDoc.paragraphStyles.add({
		name: "weeknumber",
		pointSize: 5,
		basedOn: myParagraphStyleDays,
		fillColor: weekNumberColor
		});
	// названия месяцев
	var myParagraphStyleMonths=myDoc.paragraphStyles.add({
		name: "months",
		basedOn: myParagraphStyleDays,
		justification: Justification.centerAlign,
		fillColor: monthsColor,
		pointSize: 6
		});
	// названия дней недели
	var myParagraphStyleWeekDays=myDoc.paragraphStyles.add({
		name: "weekdays",
		basedOn: myParagraphStyleDays,
		pointSize: 4
		});
	// названия дней недели - субботы
	var myParagraphStyleWeekSaturdays=myDoc.paragraphStyles.add({
		name: "weeksaturdays",
		basedOn: myParagraphStyleWeekDays,
		fillColor: saturdaysColor
		});
	// названия дней недели - воскресенья
	var myParagraphStyleWeekSundays=myDoc.paragraphStyles.add({
		name: "weeksundays",
		basedOn: myParagraphStyleWeekDays,
		fillColor: sundaysColor
		});
	// номера недель заголовок
	var myParagraphStyleWeekNumberName=myDoc.paragraphStyles.add({
		name: "WeekNumberName",
		basedOn: myParagraphStyleWeekDays,
		fillColor: weekNumberColor
	});
//создание стилей ячеек таблицы
	//календарная сетка (дни)
	var myCellDays=myDoc.cellStyles.add({
		name: "days", 
		bottomEdgeStrokeWeight: "0 pt",						//толщина обводки снизу
				topEdgeStrokeWeight: "0 pt",							//толщина обводки сверху
				leftEdgeStrokeWeight: "0 pt",						//толщина обводки слева
				rightEdgeStrokeWeight: "0 pt",						//толщина обводки справа
				topInset: "0.1 pt",									//Отступ сверху
				bottomInset: "0.1 pt",								//Отступ снизу
				leftInset: "0.1 pt",									//Отступ слева
				rightInset: "0.1 pt"								//Отступ справа

	});
	//дни недели
	var myCellWeekDays=myDoc.cellStyles.add({
		name: "week_days",
		basedOn: myCellDays
	});
	//месяцы
	var myCellMonths=myDoc.cellStyles.add({
		name: "months",
		basedOn: myCellDays
	});
	//недели
	var myCellWeeks=myDoc.cellStyles.add({
		name: "weeks",
		basedOn: myCellDays
	});
}

// заполнение массивов месяцев
function CompleteDayInMonth()
{
	var currentWeek=52;
		var myDate=new Date(myYear, 1, 1);
		if (myDate.getDay()==4) currentWeek=0;
		var current_day=myDate.getDay()+4;
		if (myKvartalWeeks_from1.checkedState) currentWeek=1;
	weekOfdayInMonth=new Array(12);
	var dayInMonth=new Array(12);
	for (month=0; month<12; month++)
	{
		dayInMonth[month]=new Array();
		weekOfdayInMonth[month]=new Array();
		var myDate=new Date(myYear, month, 1);
		var j=0;
		while (myDate.getMonth()==month) 
		{
			dayInMonth[month][j]=new Array(7);
			weekOfdayInMonth[month][j]=currentWeek;
			myDayOfWeek=myDate.getDay();
			if (myDayOfWeek==0) myDayOfWeek=7;
			for (i=1; i<=7; i++)
			{
				myDayOfWeek=myDate.getDay();
				if (myDayOfWeek==0) myDayOfWeek=7;
				if (myDate.getMonth()==month)
				{
					if (myDayOfWeek==i)
					{
						dayInMonth[month][j][i-1]=myDate.getDate();
						myDate.setDate(myDate.getDate()+1);
						if (current_day>7) current_day-=7;
						if (current_day==1)
						{
							currentWeek++;
							if (currentWeek>52) currentWeek=1;
							weekOfdayInMonth[month][j]=currentWeek;
						}
						current_day++;
					}
					else
					{
						dayInMonth[month][j][i-1]=" ";	
					}
				}
				else
				{
					dayInMonth[month][j][i-1]=" ";	
				}
			}
			j++;
		}
	}
	return dayInMonth;
}

// создание горизонтальной календарной сетки
function horizontalMonth(m_begin, m_end, w_days, month_name)
{
	for (month=m_begin; month<=m_end; month++)	// для каждого месяца:
	{
		
//  изменение положения прогрессбара
		myProgressPanel.myProgressBar.value = (month-m_begin);
		
		if (myKvartalCalendar.checkedState)
		// если создаётся квартальный календарь то добавляется страница для каждого месяца
		// и на каждой странице создаётся текстовый блок в размер страницы
		{
			if (month==m_begin)
			{	
				myPages[month-m_begin]=myDoc.pages[0];
			}
			else 
			{	
				myPages[month-m_begin]=myDoc.pages.add();
			}
			myTextFrame[month]=myPages[month-m_begin].textFrames.add({
				geometricBounds: [myDocMarginUp.editValue, myDocMarginLeft.editValue, myDocHeight.editValue-myDocMarginDown.editValue, myDocWidth.editValue-myDocMarginRight.editValue],
				label: "month"
				});
		}
		else
		// если создаётся карманный календарь то просто создаются текстовые блоки на одной странице
		{
			myTextFrame[month]=myDoc.textFrames.add({
				geometricBounds: getMonthGeometric(month),
				label: "month"
				});
		}
	// определение параметров таблицы
		// заголовок таблицы
		var tmp_table_header=0;
		if (month_name) {tmp_table_header++}; //строка с названием месяца
		if (w_days) {tmp_table_header++};     //строка с днями недели
		// проверка на добавление номеров недель
		var addWeekNumber=0;
		if (myKvartalWeeks.checkedState) addWeekNumber=1;

		
		// создание таблицы месяца
		myTable[month]=myTextFrame[month].tables.add({
			headerRowCount: tmp_table_header,   // шапка таблицы
			columnCount: 7+addWeekNumber,  		// количество колонок
			width: myTextFrame[month].geometricBounds[3]-myTextFrame[month].geometricBounds[1]-1, // ширина таблицы
			bodyRowCount: dayInMonth[month].length,   // тело таблицы
			});


		
		// установка начальных параметров обводок таблицы
		with (myTable[month].cells) cellsOfTable=itemByRange(firstItem(), lastItem());
		with (cellsOfTable)
		{
//				bottomEdgeStrokeWeight=0+"pt";						//толщина обводки снизу
//				topEdgeStrokeWeight=0+"pt";							//толщина обводки сверху
//				leftEdgeStrokeWeight=0+"pt";						//толщина обводки слева
//				rightEdgeStrokeWeight=0+"pt";						//толщина обводки справа
				height=((myTextFrame[month].geometricBounds[2]-myTextFrame[month].geometricBounds[0])/(tmp_table_header+6)-.2);
//				topInset=0.1+"pt";									//Отступ сверху
//				bottomInset=0.1+"pt";								//Отступ снизу
//				leftInset=0.1+"pt";									//Отступ слева
//				rightInset=0.1+"pt";								//Отступ справа
				autoGrow=true;
		}
		


		var tmp_current_row=0;
		var tmp_current_col=0;
		// добавление названий месяцев
		if (month_name)
		{
			with (myTable[month].rows[tmp_current_row].cells[0])
			{
				contents=addMonthName(month_name, month)+myAddYear;
				paragraphs[0].appliedParagraphStyle="months";
				merge(myTable[month].rows[tmp_current_row]);
				appliedCellStyle="months"; //присвоение ячейке стиля months
			}
			tmp_current_row++;
		}
		// добавление дней недели
		if (w_days)
		{
				if (addWeekNumber)
				{
					myTable[month].rows[tmp_current_row].cells[0].contents="неделя";
					myTable[month].rows[tmp_current_row].cells[0].paragraphs[0].appliedParagraphStyle="WeekNumberName";
					myTable[month].rows[tmp_current_row].cells[0].appliedCellStyle="week_days";
				}
				for (i=0; i<7; i++)
				{
					myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].contents=addNameOfWeekDay(w_days, i);
					myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="weekdays";
					if (i==5) myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="weeksaturdays";
					if (i==6) myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="weeksundays";
					myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].appliedCellStyle="week_days";
				}
				tmp_current_row++;
		}
		// заполнение дней месяца  
		for (var j=0; j<dayInMonth[month].length; j++)
		{
			if (addWeekNumber)
			{
				myTable[month].rows[tmp_current_row].cells[0].contents=weekOfdayInMonth[month][j].toString();
				myTable[month].rows[tmp_current_row].cells[0].paragraphs[0].appliedParagraphStyle="weeknumber";
				myTable[month].rows[tmp_current_row].cells[0].appliedCellStyle="weeks";
			}
			for (i=0; i<7; i++)
			{
				myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].contents=dayInMonth[month][j][i].toString();
				myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="days";
				if (i==5) myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="saturdays";
				if (i==6) myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="sundays";
				myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].appliedCellStyle="days";
				for (p=0; p<prazdnik[month].length; p++)
				{
					if (dayInMonth[month][j][i]==prazdnik[month][p])
					{
						myTable[month].rows[tmp_current_row].cells[i+addWeekNumber].paragraphs[0].appliedParagraphStyle="holydays";
					}
				}
			}
			tmp_current_row++;
		}
	}
}

// создание вертикальной календарной сетки
function verticalMonth(m_begin, m_end, w_days, month_name)
{
	for (month=m_begin; month<=m_end; month++)	// для каждого месяца:
	{
		
		//  изменение положения прогрессбара
		myProgressPanel.myProgressBar.value = (month-m_begin);

		if (myKvartalCalendar.checkedState)
		// если создаётся квартальный календарь то добавляется страница для каждого месяца
		// и на каждой странице создаётся текстовый блок в размер страницы
		{
			if (month==m_begin)
			{	
				myPages[month-m_begin]=myDoc.pages[0];
			}
			else 
			{	
				myPages[month-m_begin]=myDoc.pages.add();
			}
			myTextFrame[month]=myPages[month-m_begin].textFrames.add();
			myTextFrame[month].geometricBounds=[myDocMarginUp.editValue, myDocMarginLeft.editValue, myDocHeight.editValue-myDocMarginDown.editValue, myDocWidth.editValue-myDocMarginRight.editValue];
		}
		else
		// если создаётся карманный календарь то просто создаются текстовые блоки на одной странице
		{
			myTextFrame[month]=myDoc.textFrames.add();
			myTextFrame[month].geometricBounds=getMonthGeometric(month);
		}
		myTextFrame[month].label="month";
		
		// заголовок таблицы
		var tmp_table_header=0;
		if (month_name) {tmp_table_header++}; //строка с названием месяца
		
		var tmp_table_weekdays=0;
		if (!myDropWeekDaysPosition.selectedIndex)
		{
		if (w_days)
		 	{tmp_table_weekdays++};     //столбец с днями недели
		};
		
		
		// создание таблицы месяца
		myTable[month]=myTextFrame[month].tables.add({
			headerRowCount: tmp_table_header,   // шапка таблицы
			columnCount: dayInMonth[month].length+tmp_table_weekdays,  		// количество колонок
			width: myTextFrame[month].geometricBounds[3]-myTextFrame[month].geometricBounds[1]-1, // ширина таблицы
			bodyRowCount: 7,   // тело таблицы
			});

		
		// установка начальных параметров обводок таблицы
		with (myTable[month].cells) cellsOfTable=itemByRange(firstItem(), lastItem());
		with (cellsOfTable)
		{
//				bottomEdgeStrokeWeight=0+"pt";						//толщина обводки снизу
//				topEdgeStrokeWeight=0+"pt";							//толщина обводки сверху
//				leftEdgeStrokeWeight=0+"pt";						//толщина обводки слева
//				rightEdgeStrokeWeight=0+"pt";						//толщина обводки справа
				height=((myTextFrame[month].geometricBounds[2]-myTextFrame[month].geometricBounds[0])/(tmp_table_header+7)-.5);
//				topInset=0.1+"pt";									//Отступ сверху
//				bottomInset=0.1+"pt";								//Отступ снизу
//				leftInset=0.1+"pt";									//Отступ слева
//				rightInset=0.1+"pt";								//Отступ справа
//				autoGrow=true;
		}
		
		var tmp_current_row=0;
		// добавление названий месяцев
		if (month_name)
		{
			myTable[month].rows[tmp_current_row].cells[0].contents=addMonthName(month_name, month)+myAddYear;
			myTable[month].rows[tmp_current_row].cells[0].paragraphs[0].appliedParagraphStyle="months";
			myTable[month].rows[tmp_current_row].cells[0].merge(myTable[month].rows[tmp_current_row]);
			myTable[month].rows[tmp_current_row].cells[0].appliedCellStyle="months"; //присвоение ячейке стиля months
			tmp_current_row++;
		}
		// заполнение дней месяца
		for (i=0; i<7; i++)
		{
			var tmp_current_col=0;
				if (!myDropWeekDaysPosition.selectedIndex)
				{
					if (w_days)		// добавление дней недели
					{
						myTable[month].rows[tmp_current_row+i].cells[0].contents=addNameOfWeekDay(w_days, i);
						myTable[month].rows[tmp_current_row+i].cells[0].paragraphs[0].appliedParagraphStyle="weekdays";
						if (i==5) myTable[month].rows[tmp_current_row+i].cells[0].paragraphs[0].appliedParagraphStyle="weeksaturdays";
						if (i==6) myTable[month].rows[tmp_current_row+i].cells[0].paragraphs[0].appliedParagraphStyle="weeksundays";
						myTable[month].rows[tmp_current_row+i].cells[0].appliedCellStyle="week_days";
						tmp_current_col=1;
					}
				}
			for (j=0; j<dayInMonth[month].length; j++)
			{
				with (myTable[month].rows[tmp_current_row+i].cells[tmp_current_col+j])
				{
					contents=dayInMonth[month][j][i].toString();
					paragraphs[0].appliedParagraphStyle="days";
					if (i==5) paragraphs[0].appliedParagraphStyle="saturdays";
					if (i==6) paragraphs[0].appliedParagraphStyle="sundays";
					appliedCellStyle="days";
					for (p=0; p<prazdnik[month].length; p++)
					{
							if (dayInMonth[month][j][i]==prazdnik[month][p])
							{
								paragraphs[0].appliedParagraphStyle="holydays";
							}
					}

				}
			}
		}
	}
}


// вычисляются размеры текстовых блоков для размещения на одной странице
function getMonthGeometric(m_num)
{
	var docWidth=myDocWidth.editValue;
	var docHeight=myDocHeight.editValue;
	var leftMargin=myDocMarginLeft.editValue;
	var rightMargin=myDocMarginRight.editValue;
	var bottomMargin=myDocMarginDown.editValue;
	var topMargin=myDocMarginUp.editValue;

	switch (MonthPalacementSelect) 
	{
		case 0:
			var countMonthWidth=12;
			var countMonthHeight=1;
			break;
		case 1:
			var countMonthWidth=6;
			var countMonthHeight=2;
			break;
		case 2:
			var countMonthWidth=4;
			var countMonthHeight=3;
			break;
		case 3:
			var countMonthWidth=3;
			var countMonthHeight=4;
			break;
		case 4:
			var countMonthWidth=2;
			var countMonthHeight=6;
			break;
		case 5:
			var countMonthWidth=1;
			var countMonthHeight=12;
			break;
	}
// изменяем поля, если нужно поставить названия дней недели только в строках месяцев
	var monthWidth=(docWidth-leftMargin-rightMargin)/countMonthWidth;
	if (weekDays)
	{
		switch (myDropWeekDaysPosition.selectedIndex)
		{
			case 0:
				break;
			case 1:
				var leftMargin=leftMargin+monthWidth/5;
				break;
			case 2:
				var rightMargin=rightMargin+monthWidth/5;
				break;
			case 3:
				var leftMargin=leftMargin+monthWidth/5;
				var rightMargin=rightMargin+monthWidth/5;
				break;		
		};
	};
	var monthWidth=(docWidth-leftMargin-rightMargin)/countMonthWidth;
	var monthHeight=(docHeight-topMargin-bottomMargin)/countMonthHeight;
	var x1=leftMargin+monthWidth*(m_num-Math.floor(m_num/countMonthWidth)*countMonthWidth);
	var y1=topMargin+monthHeight*Math.floor(m_num/countMonthWidth);
	var myGeometricBounds=new Array(y1, x1, y1+monthHeight, x1+monthWidth);
	return myGeometricBounds;
}

// добавление названий месяцев
function addMonthName(month_name_type, n_month)
{
	var nameofmonth=null;
	if (month_name_type)
	{
		switch (month_name_type-Math.floor(month_name_type/3)*3) 
		{
			case 1:
				nameofmonth=MonthNames[Math.floor(month_name_type/3)][n_month];
				break;
			case 2:
				nameofmonth=MonthNames[Math.floor(month_name_type/3)][n_month].toLowerCase();
				break;
			case 0:
				nameofmonth=MonthNames[Math.floor(month_name_type/3)-1][n_month].toUpperCase();
				break;
		}
	}
	return nameofmonth;
}

// добавление названий дней недели
function addNameOfWeekDay(w_days_type, n_day)
{
	var nameofday=null;
	if (w_days_type)
	{
		var casevar=w_days_type-Math.floor(w_days_type/3)*3;
		switch (casevar) 
		{
			case 1:
				nameofday=DaysOfWeek[Math.floor(w_days_type/3)][n_day];
				break;
			case 2:
				nameofday=DaysOfWeek[Math.floor(w_days_type/3)][n_day].toLowerCase();
				break;
			case 0:
				nameofday=DaysOfWeek[Math.floor(w_days_type/3)-1][n_day].toUpperCase();
				break;
		}
	}
	return nameofday;
}
// создание ProgressPaneli
function myCreateProgressPanel(myMaximumValue, myProgressBarWidth){
	myProgressPanel = new Window('window', 'Генерация календаря');
	with(myProgressPanel){
		myProgressPanel.myProgressBar = add('progressbar', [12, 12, myProgressBarWidth, 24], 0, myMaximumValue);
	}
	return myProgressPanel;
}